program Demo;

{$APPTYPE CONSOLE}

uses
  SysUtils, uFreeTimer, SyncObjs;

var CS:TCriticalSection;

type TTimerTest = class
  private
    fTimer: TFreeTimer;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Timer(Sender: TObject);
  end;

constructor TTimerTest.Create;
begin
  fTimer := TFreeTimer.Create(nil);
  fTimer.Interval := 500;
  fTimer.Synchronize := false;
  fTimer.OnTimer := Timer;
end;

destructor TTimerTest.Destroy;
begin
  fTimer.free;
  inherited;
end;

procedure TTimerTest.Timer(Sender: TObject);
begin
  Cs.Acquire; //not really necessary here
  try
    writeln(TimeToStr(now));
  finally
    CS.Release;
  end;
end;

var
  s: string;
  Test: TTimerTest;

begin
  CS:=TCriticalSection.Create;
  Test := TTimerTest.Create;
  ReadLn(s); //wait for Return;
  Test.free;
  CS.free;
end.
